package main;

import person.Gender;
import person.Person;

import java.util.*;

public class PersonTest {

    private static final Person AGENT_SMITH = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);
    private static final Person TRINITY = Person.makePerson("Trinity", "Trin", "hacker", Gender.FEMALE, 2031);
    private static final Person NEO = Person.makePerson("Thomas", "Anderson", "redeemer", Gender.MALE, 2029);

    private static final Person CLONE_OF_SMITH_A = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);
    private static final Person CLONE_OF_SMITH_B = Person.makePerson("Agent", "Smith", "agent", Gender.MALE, 2035);

    public static void main(String[] args) {
        List<Person> matrixCharacters = Arrays.asList(AGENT_SMITH, TRINITY, NEO, CLONE_OF_SMITH_A, CLONE_OF_SMITH_B, NEO);
        Map<Person, Integer> personMultiset = countPersonsIn(matrixCharacters);

        // vagy for(Map.Entry<Person, Integer> personAndCount : personMultiset.entrySet()) ...
        for (Person person : personMultiset.keySet()) { 
            int count = personMultiset.get(person);
            System.out.println(person + " was found " + (count == 1 ? "once" : count + " times"));
        }
    }

    private static Map<Person, Integer> countPersonsIn(List<Person> persons) {
        Map<Person, Integer> personMultiset = new HashMap<>();
        for (Person person : persons) {
            if (personMultiset.containsKey(person)) {
                Integer currentCount = personMultiset.get(person);
                personMultiset.put(person, currentCount + 1);
            } else {
                personMultiset.put(person, 1);
            }
        }
        return personMultiset;
    }

}